.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include DlgMain.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax
	
	invoke GetSystemDirectory,OFFSET szTargetFile,MAX_PATH
	invoke lstrcat,OFFSET szTargetFile,OFFSET szshell32
	
    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL hIcoFile	:DWORD
	.if uMsg==WM_INITDIALOG
; Find out how many icons there are and create a buffer for the res names
		invoke ExtractIcon,[hInstance],ADDR szTargetFile,-1
		mov [nIconsInFile],eax
		or eax,eax
		jz @ret
		shl eax,6
		invoke GlobalAlloc,GMEM_ZEROINIT,eax
		mov [pIconList],eax
	
		
		; load the file as a library
		invoke LoadLibraryEx,ADDR szTargetFile,NULL,LOAD_LIBRARY_AS_DATAFILE
		mov [hLibFile],eax
		
		invoke BuildIndexTable,[pIconList]
		or eax,eax
		jz @F
		
		invoke CreateFile,OFFSET szTestFile,GENERIC_WRITE,NULL,NULL,CREATE_ALWAYS,NULL,NULL
		mov [hIcoFile],eax

		mov eax,10 ; index number
		shl eax,6
		add eax,[pIconList]
		invoke SaveIconResource,[hLibFile],eax,[hIcoFile]
		@@:
		invoke FreeLibrary,[hLibFile]
		invoke GlobalFree,[pIconList]
		
		
		@ret:
	.elseif uMsg==WM_COMMAND

     
	.elseif uMsg==WM_CLOSE
		invoke EndDialog,hWnd,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

;hModule = module handle returned from LoadLibraryEx
;pResName = reource identifier for RT_GROUP_ICON resource
;hFile = Handle to the output file (*.ico)

SaveIconResource PROC hModule:DWORD,pResName:DWORD,hFile:DWORD
	;uses edi,esi
	LOCAL hFindRes		:DWORD
	LOCAL hResData		:DWORD
	LOCAL pResData		:DWORD
	LOCAL ResSize		:DWORD
	LOCAL iCount		:DWORD
	LOCAL pOutput		:DWORD
	LOCAL cbWritten		:DWORD
	LOCAL cbWrite		:DWORD
	LOCAL iResName[16]	:BYTE
	LOCAL StrOffset		:DWORD

	invoke FindResource,[hModule],[pResName],RT_GROUP_ICON
	mov [hFindRes],eax
	invoke SizeofResource,[hModule],[hFindRes]
	mov [ResSize],eax
	or eax,eax
	jnz @1
		dec eax
		ret
	@1:
	mov [iResName],"#";mov B[iResName],23h;"#"

	invoke LoadResource,[hModule],[hFindRes]
	mov [hResData],eax
	invoke LockResource,[hResData]
	mov [pResData],eax
	or eax,eax
	jnz @2
		dec eax
		ret
	@2:

	; Calculate the size of the file
	mov edi,eax
	xor ecx,ecx
	mov cx,[edi+GRPICONDIR.idCount]
	mov [iCount],ecx;mov D[iCount],ecx
	add edi,SIZEOF GRPICONDIR
	mov eax,SIZEOF GRPICONDIR
	@3:
		add eax,[edi+GRPICONDIRENTRY.dwBytesInRes]
		add eax,SIZEOF GRPICONDIRENTRY
		add edi,SIZEOF GRPICONDIRENTRY
	dec ecx
	jnz @3

	mov ecx,[iCount]
	shl ecx,1
	add eax,ecx
	mov [cbWrite],eax
	invoke GlobalAlloc,GPTR,eax
	mov [pOutput],eax
	
	mov esi,[pResData]
	mov edi,[pOutput]
	; Copy the header
	invoke memcopy,[pResData],[pOutput],SIZEOF GRPICONDIR
	; Move the pointers up
	add esi,SIZEOF GRPICONDIR
	add edi,SIZEOF GRPICONDIR
	; Copy the array of Icon dir entries
	xor ecx,ecx
	@4:
		; Copy the icon entry
		invoke memcopy,esi,edi,SIZEOF GRPICONDIRENTRY
		; mov the pointers up
		add esi,SIZEOF GRPICONDIRENTRY
		add edi,SIZEOF GRPICONDIRENTRY
		; An extra 2 for the destination index
		add edi,2
		inc ecx
	cmp ecx,[iCount]
	jne @4

	xor ecx,ecx
	; reset the source index to the first GRPICONDIRENTRY
	mov esi,[pResData]
	add esi,SIZEOF GRPICONDIR
	; reset the Destination index to the first ICONDIRENTRY
	mov eax,[pOutput]
	add eax,SIZEOF GRPICONDIR
	mov [StrOffset],eax

	@5:
		push ecx
		; Get the id of the icon
		lea ecx,[iResName]
		inc ecx
		movzx eax,[esi+GRPICONDIRENTRY.nID];movzx eax,W[esi+GRPICONDIRENTRY.nID]
		invoke dwtoa,eax,ecx

		; Get a copy of the icon resource
		invoke FindResource,[hModule],ADDR iResName,RT_ICON
		mov [hFindRes],eax
		invoke SizeofResource,[hModule],[hFindRes]
		mov [ResSize],eax
		invoke LoadResource,[hModule],[hFindRes]
		mov [hResData],eax
		invoke LockResource,[hResData]
		mov [pResData],eax

		; Copy the icon data to the buffer
		invoke memcopy,[pResData],edi,[esi+GRPICONDIRENTRY.dwBytesInRes]

		; move the offset of this data to the array
		mov ecx,edi
		sub ecx,[pOutput]
		mov eax,[StrOffset]
		mov [eax+ICONDIRENTRY.dwImageOffset],ecx
		add [StrOffset],SIZEOF ICONDIRENTRY;add D[StrOffset],SIZEOF ICONDIRENTRY

		; Increment the destination pointer
		add edi,[esi+GRPICONDIRENTRY.dwBytesInRes]

		; Increment the source pointer
		add esi,SIZEOF GRPICONDIRENTRY
		pop ecx
		inc ecx
	cmp ecx,[iCount]
	jne @5

	invoke WriteFile,[hFile],[pOutput],[cbWrite],ADDR cbWritten,NULL
	invoke FlushFileBuffers,[hFile]
	invoke CloseHandle,[hFile]

	invoke GlobalFree,[pOutput]
	mov eax,[cbWritten]
	ret

SaveIconResource endp

BuildIndexTable PROC pTable:DWORD
	mov dwNDX,0;mov D[dwNDX],0
	invoke EnumResourceTypes,[hLibFile],OFFSET ResTypeEnumFunction,[pTable]
	mov eax,dwNDX
		
	RET
BuildIndexTable ENDP

ResTypeEnumFunction Proc hModule:DWORD,lpszType:DWORD,lParam:DWORD

	cmp [lpszType],RT_GROUP_ICON;cmp D[lpszType],RT_GROUP_ICON
	jne @F
	
	invoke EnumResourceNames,[hLibFile],[lpszType],addr ResEnumFunction,[lParam]
	@@:
	xor eax,eax
	inc eax
	ret
ResTypeEnumFunction endp

ResEnumFunction PROC hModule:DWORD,lpType:DWORD,lpName:DWORD,lParam:DWORD
	LOCAL rsName[64]:BYTE
	LOCAL IconIndex			:DWORD

	mov eax,[lpName]
	shr eax,16
	or ax,ax
	jnz @1
			
		lea ecx,rsName
		mov [ecx],27h
		inc ecx

		invoke dwtoa,addr lpName,ecx

		jmp @2
	@1:
	
		invoke lstrcpy,ADDR rsName,[lpName]
	@2:

	cmp [lpType],RT_GROUP_ICON;cmp D[lpType],RT_GROUP_ICON
	jne @3

		mov esi,[dwNDX]
		shl esi,6
		add esi,[lParam]
		invoke lstrcpy,esi,ADDR rsName
		inc [dwNDX];inc D[dwNDX]
	@3:
	xor eax,eax
	inc eax
	ret
ResEnumFunction endp

memcopy Proc lpSource:DWORD,lpDest:DWORD,nBytes:DWORD
	;uses edi,esi,ecx
	;cld
	mov edi,[lpDest]
	mov esi,[lpSource]
	mov ecx,[nBytes]
	
	; do the evenly divisible ones
	shr ecx,2
	rep movsd
	
	; do the remainder
	mov ecx,[nBytes]
	and ecx,3
	rep movsb
	
	RET
memcopy endp


end start
